#! /usr/bin/env python
# -*- coding: utf-8 -*-
# vim:set sts=4:tabstop=4:expandtab:shiftwidth=4:
import os, re

def system():
    """
    Get system name, can be one of Ubuntu/Kubuntu/Xubuntu
    """
    issue_file = open('/etc/issue','r')
    distribution_line = issue_file.readline()
    tokens = distribution_line.split(" ")
    return tokens[0].lower()

def architecture():
    """
    Detect whether the architecture is x86/ppc/amd64 and localise a sources.list
    based on your original sources.list
    """
    uname = os.popen('uname -r')
    kernel_line = uname.readline()
    kernel_line = kernel_line.strip()
    uname.close()
    tokens = kernel_line.split("-")
    arch = tokens[-1]
    if arch in ('386','686','k7'):
        arch = 'x86'
    return arch

def replace(confdir):
    """
    Create a localised sources.list first, with universe and multiverse
    """
    sourcelist = open('/etc/apt/sources.list', 'r')
    try:
        os.remove(os.path.join(confdir,'sources.list'))
    except OSError:
        #print "File already removed"
        pass

    targetlist = open(os.path.join(confdir, 'sources.list'),'w')
    while True:
        line = sourcelist.readline()
        if len(line) == 0: # Zero length indicates EOF
            break
        if not re.search("cdrom",line):
            if re.search("^deb ",line): #Space is significant!
                if re.search("feisty ",line):
                    repos_components = line.split
                    repos_URI = repos_components()[1]
                    repos_string="deb " + repos_URI + " feisty main restricted universe multiverse\n"
                    targetlist.write(repos_string)
                    break
    
    # close the file (no need for keeping file open anymore)
    sourcelist.close()
    
    if architecture() == 'powerpc':
        print 'PowerPC Detected'
        targetlist.write("deb http://medibuntu.sos-sts.com/repo/ feisty free non-free \n")
        #targetlist.write("deb http://deb.opera.com/opera etch non-free \n")
    
    elif architecture() == 'x86':
        print 'x86 Detected'
        targetlist.write("deb http://medibuntu.sos-sts.com/repo/ feisty free non-free \n")
        targetlist.write("deb deb http://wine.budgetdedicated.com/apt feisty main \n")
        targetlist.write("deb http://deb.opera.com/opera/ feisty non-free \n")
        targetlist.write("deb http://archive.canonical.com/ubuntu feisty-commercial main \n")
        # Do x86 installation tasks

    elif architecture() == 'amd64':
        print 'AMD64 detected'
    # No Modification to the sources is required, additional repositories are not supported
    # Do Amd64 installation tasks
    else:
        print 'No supported architectures found, please contact authors for help'
    # This is an error by me, i guess :)
    targetlist.write("# The above lines were generated automatically by Homa Magic AddOn CD.\n") 
    targetlist.write("# The rest of your sources.list follows\n\n\n")
    #Code for putting in remaining repositories than the ones modified
    sourcelist = open('/etc/apt/sources.list', 'r')
    while True:
        line = sourcelist.readline()
        if len(line) == 0: # Zero length indicates EOF
            break
        if (re.search("^deb-src",line) or not re.search("feisty ",line)\
                or re.search('^cdrom',line) or re.search('^#',line)):
                targetlist.write(line)
    
    sourcelist.close()
    targetlist.close()
    print "Customized sources.list generated"

if __name__ == "__main__":
    replace(os.path.abspath('./conf'))
